<?php
/*
Plugin Name: Tag To Name
Version: 0.0.0.1
Description: remplace le nom d'un fichier par un fabiqué avec les tags de l'image
Plugin URI: http://www.phpwebgallery.net
Author: h2o
Author URI: http://www.datacombes.com
*/

class tag_to_name    {
    var $plugin_name, $plugin_path, $plugin_url;
    var $my_config;
    var $config = array();

    function tag_to_name   ($plugin_name, $plugin_path, $plugin_url) {
        // Args
        $this->plugin_name = $plugin_name;
        $this->plugin_path = $plugin_path;
        $this->plugin_url = $plugin_url;        
        $this->classement = array();
        // recuperation de la config dans la ddb
        $this->config(); 
        // handler
        $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);        
    }

    function initialize_event_handler() {        
        // remplacement du titre sous les vignettes à l'affichage des catégories
        add_event_handler('loc_end_index_thumbnails', array($this, 'TagCategoryThumbnail'), 50, 2);
        // remplacement du titre de la page à l'affichage de la photo
        add_event_handler('loc_end_page_header', array($this, 'TagTitlePicture'), 60);
        // remplacement du nom de la photo à l'affichage de la photo
        add_event_handler('loc_end_picture', array($this, 'TagNamePicture'), 65);           
    }
    
    // remplace le nom de la photo (current.TITLE) dans la page picture par ses tags
    function TagNamePicture($tpl_var) {       
        global $template, $page;        
	     $current = $template->get_template_vars('current');	     
	    // verification si c'est la page picture	   
	    if($this->is_page_picture() && $this->verif_remplacement($current['TITLE']))
	    {	        	        
	        $temp = $this->fabriqueListeMotClef( $page['image_id']);	        	        
	        $template->assign('current', array('TITLE' => $temp)); 
	    }
    }   
    
    // remplace le titre (PAGE_TITLE) de la page picture par ses tags
    function TagTitlePicture($tpl_var) {       
        global $template, $page;     
	    $title = $template->get_template_vars('PAGE_TITLE');	      
	    if($this->is_page_picture() && $this->verif_remplacement($title))
	    {	        
	        $temp = $this->fabriqueListeMotClef( $page['image_id']);	        	        
	        $template->assign('PAGE_TITLE', $temp);	        
	    }	    
    }
    
    // Remplace le nom par les mots clefs
    function TagCategoryThumbnail($tpl_var) {        
	    foreach($tpl_var as $cle=>$valeur) {			
			if($this->verif_remplacement($tpl_var[$cle]['ID']))
			{
			     $tpl_var[$cle]['NAME'] =  $this->fabriqueListeMotClef($tpl_var[$cle]['ID']);
			}			
        }   // end foreach    
        return $tpl_var;        
    } 
          
    // Recupere la liste des mots clef d'une image
    function fabriqueListeMotClef($cle) {                        
        $txt = '';
        $tags = array();
        // TAGS_TABLE & IMAGE_TAG_TABLE   
        $sql = 'SELECT i.*, t.name FROM '.IMAGE_TAG_TABLE.' i
			LEFT JOIN ' . TAGS_TABLE . ' t ON t.id = i.tag_id 
			WHERE image_id = '.$cle.'			
			;';		
		$result = pwg_query($sql);        
        while ($row = mysql_fetch_array($result))
        {
            $tags[$row['name']] = $row['name'];             
        }   // endwhile       
        $string = $this->classementTags($tags);        
        return $string;   
    }

    // place les tags dans un ordre défini.
    function classementTags($tags) {
                   
        $string = '';    
                            
        // tri alpha-numérique
        if($this->config['tri'] = 'alpha') { natcasesort($tags); }
        
        // supprimer des mots clefs        
        if(!empty($this->config['supprimer']))
        {
            $tags_off = explode(',', $this->config['supprimer']);
            foreach($tags_off AS $cle)
            {
                unset($tags[trim($cle)]);
            }       
        }
        
        // classement
        foreach($tags AS $tag)        
        {           
         
        }        
         
        $string = implode(' ', $tags); 
           
        
        return $string;
    }   // fin function

    // Recupere la config
    function config()
    {
        $sql = 'SELECT * FROM '.tag_to_name_TABLE.';';		
        $result = pwg_query($sql);        
        while ($row = mysql_fetch_array($result))
        {
            $this->config[$row['name']] = stripslashes(trim($row['value']));
        }
    }
    
    
    // Verifie la config pour le remplacement d'un nom
    function verif_remplacement($str)  {
        if($this->config['remplacement'] == '_none_')
        {
            return FALSE;
        }
        elseif($this->config['remplacement'] == '_ALL_')
        {
            return TRUE;
        }        
        elseif($this->config['remplacement'] == trim($str))
        {
            return TRUE;
        }        
    }
    
    // vérifie si c'est la page picture.php
    function is_page_picture() {
        global $template;
        if(preg_match("`picture.php`",  $template->get_template_vars('SCRIPT_NAME')))
	    {
            return TRUE;
        }
        return FALSE;
    }
       


}   // FIN de la Class
?>
